
import java.util.*;
import java.text.DecimalFormat;

public class TestVectorRacionales
{
    public static void main(String[] args)
    {
        VectorRacionales v1, v2, v3;
        int max = 6;
  
        v1 = generaVector(max);
        v2 = generaVector(max);
        
        System.out.println("Vector v1 => ");
        mostrarVector(v1);

        
        System.out.println("Vector v2 => ");
        mostrarVector(v2);
        
        System.out.println("Testeo de los metodos: ");
        
        
        //---------------------------------------------------------------------------------------------
        //---- Test producto escalar
        //---------------------------------------------------------------------------------------------
        if (v1.cantElems() == v2.cantElems()) {
            System.out.println("Producto escalar v1 * v2 => " + v1.prodEscalar(v2)); 
        } else {
            System.out.println("No se puede calcular el producto escalar dado que la cantidad de elementos no es consistente"); 
        }
        
        //---------------------------------------------------------------------------------------------
        //---- Test suma
        //---------------------------------------------------------------------------------------------
        if (v1.cantElems() == v2.cantElems()) {
            v3 = v1.suma(v2);
            System.out.print("Suma v1 + v2 => "); 
            mostrarVector(v3);
        } else {
            System.out.println("No se puede calcular la suma dado que la cantidad de elementos no es consistente"); 
        }
        
        //---------------------------------------------------------------------------------------------
        //---- Test escalar X Vector
        //---------------------------------------------------------------------------------------------
        int esc = 2;
        v3 = v1.escalarXVector(esc) ;
        System.out.print("Escalar X vector (" + esc + " * v1) => "); 
        mostrarVector(v3);

        
        //---------------------------------------------------------------------------------------------
        //---- Test copy
        //----
         System.out.println("TEST DE COPY");
        
        System.out.print("v3= ");
        mostrarVector(v3);
        System.out.print("v2= ");
        mostrarVector(v2);
        
        System.out.println("copiando el estado interno de v2 en v3...");
        v3.copy(v2);
        System.out.print("v3= ");
        mostrarVector(v3);
        
        //---------------------------------------------------------------------------------------------
        //---- Test equals
        //----
        System.out.println("TEST DE EQUALS");
        
        System.out.print("v1= ");
        mostrarVector(v1);
        System.out.print("v2= ");
        mostrarVector(v2);
        System.out.print("v3= ");
        mostrarVector(v3);
        
        System.out.println("v1.equals(v2)? "+v1.equals(v2));
        
        System.out.println("v3.equals(v2)? "+v3.equals(v2));
        
        //---------------------------------------------------------------------------------------------
        //---- Test clone
        //----
        
        System.out.println("TEST DE CLONE");
        
        System.out.print("v1= ");
        mostrarVector(v1);
        System.out.print("v2= ");
        mostrarVector(v2);
        System.out.println("clonando v1...");
        VectorRacionales v1clon=v1.clone();
        System.out.print("v1clon= ");
        mostrarVector(v1clon);
        System.out.println("clonando v2...");
        VectorRacionales v2clon=v2.clone();
        System.out.print("v2clon= ");
        mostrarVector(v2clon);
        /**
         * @todo: completar el tester para los metodos implementados
         */
    
    }   
    
    //--------------------------------------------------------------------------------------------------
    //---- Auxiliares ----------------------------------------------------------------------------------
    //--------------------------------------------------------------------------------------------------
    
    /**
     * Crea un objeto Vector y lo inicializa con valores aleatorios
     */
    private static VectorRacionales generaVector(int max)
    {
        // Se crea el objeto de clase Vector
        VectorRacionales v = new VectorRacionales(max);
        // Se lo inicializa con números aleatorios
        Random gen = new Random();
        Racional elem;
        for (int i = 0; i < v.cantElems(); i++) {
            elem = new Racional((gen.nextInt())%20, (Math.abs(gen.nextInt())+1)%20);
            v.establecerElem(i, elem);
        }
        // Se retorna el objeto creado e inicializado
        return v;
    }
    
    /**
     * Muestra por pantalla el contenido de un objeto de clase Vector
     */
    private static void mostrarVector(VectorRacionales v)
    {
        
       
        System.out.print("< ");
        for (int i = 0; i < v.cantElems(); i++) {
            System.out.print(v.obtenerElem(i).toString() + ",");
        }
        System.out.println(">");
    }
}
