public class VectorRacionales
{
    //---------------------------------------------------------------------------------------------
    //---- Atributo de instancia
    //---------------------------------------------------------------------------------------------

    private Racional[] vec;

    //---------------------------------------------------------------------------------------------
    //---- Constructor
    //---------------------------------------------------------------------------------------------
    
    public VectorRacionales(int max)
    {
        vec = new Racional[max];
    }

    //---------------------------------------------------------------------------------------------
    //---- Comandos
    //---------------------------------------------------------------------------------------------
    
    /**
     * Asume que la posicion es valida
     */
    public void establecerElem(int pos, Racional elem)
    {
        vec[pos] = elem;
    }

  /**@todo:
     +copy(v:VectorRacionales)**/

    //---------------------------------------------------------------------------------------------
    //---- Consultas
    //---------------------------------------------------------------------------------------------
  
    public boolean existePos(int pos) 
    {
        return (pos >= 0 && pos < vec.length);
    }
    
    public boolean existeElem(Racional r)
    {
        int i = 0;
        boolean existe = false;
        while ((i < vec.length) && (!existe)) {
            if (vec[i].equals(r)) {
                existe = true;
            } else {
                i++;
            }
        }
        return existe;
    }
    
    /**
     * Asume que la posicion es valida
     */
    public Racional obtenerElem(int pos)
    {
        return vec[pos];
    }

    public int cantElems()
    {
        return vec.length;
    }

    /**@todo:
     * +prodEscalar(v:VectorRacionales):Racional
     * Asume que las longitudes son consistentes
     */
 
  
     /**@todo:
     * +suma(v:VectorRacionales):VectorRacionales
     * Asume que las longitudes son consistentes
     */
 

    public VectorRacionales escalarXVector(int esc) 
    {
        VectorRacionales aux = new VectorRacionales(vec.length);
        Racional escalarEnRacional= new Racional(esc,1);
        for (int i = 0; i < vec.length; i++) {      
            aux.establecerElem(i,vec[i].producto(escalarEnRacional)); 
        }
        return aux;
    }

    
    /**
     * @todo: 
     *  + equals(v:Vector): boolean
     *  + clone():Vector
     */
}
